Bug 1933: Fix ready check
[osm/devops.git] / installers / charmed_install.sh
1 #! /bin/bash
2 #
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at
6 #
7 # http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14 #
15
16 # set -eux
17
18 LXD_VERSION=4.0
19 JUJU_VERSION=2.9
20 JUJU_AGENT_VERSION=2.9.22
21 K8S_CLOUD_NAME="k8s-cloud"
22 KUBECTL="microk8s.kubectl"
23 MICROK8S_VERSION=1.23
24 OSMCLIENT_VERSION=latest
25 IMAGES_OVERLAY_FILE=~/.osm/images-overlay.yaml
26 PASSWORD_OVERLAY_FILE=~/.osm/password-overlay.yaml
27 PATH=/snap/bin:${PATH}
28
29 MODEL_NAME=osm
30
31 OSM_BUNDLE=ch:osm
32 OSM_HA_BUNDLE=ch:osm-ha
33 CHARMHUB_CHANNEL=latest/edge
34 unset TAG
35
36 function check_arguments(){
37 while [ $# -gt 0 ] ; do
38 case $1 in
39 --bundle) BUNDLE="$2" ;;
40 --overlay) OVERLAY="$2" ;;
41 --k8s) KUBECFG="$2" ;;
42 --vca) CONTROLLER="$2" ;;
43 --lxd) LXD_CLOUD="$2" ;;
44 --lxd-cred) LXD_CREDENTIALS="$2" ;;
45 --microstack) MICROSTACK=y ;;
46 --ha) BUNDLE=$OSM_HA_BUNDLE ;;
47 --tag) TAG="$2" ;;
48 --registry) REGISTRY_INFO="$2" ;;
49 --only-vca) ONLY_VCA=y ;;
50 esac
51 shift
52 done
53
54 # echo $BUNDLE $KUBECONFIG $LXDENDPOINT
55 }
56
57 function install_snaps(){
58 if [ ! -v KUBECFG ]; then
59 sudo snap install microk8s --classic --channel=${MICROK8S_VERSION}/stable
60 sudo cat /var/snap/microk8s/current/args/kube-apiserver | grep advertise-address || (
61 echo "--advertise-address $DEFAULT_IP" | sudo tee -a /var/snap/microk8s/current/args/kube-apiserver
62 microk8s.stop
63 microk8s.start
64 )
65 sudo usermod -a -G microk8s `whoami`
66 mkdir -p ~/.kube
67 sudo chown -f -R `whoami` ~/.kube
68 KUBEGRP="microk8s"
69 sg ${KUBEGRP} -c "microk8s status --wait-ready"
70 KUBECONFIG=~/.osm/microk8s-config.yaml
71 sg ${KUBEGRP} -c "microk8s config" | tee ${KUBECONFIG}
72 else
73 KUBECTL="kubectl"
74 sudo snap install kubectl --classic
75 export KUBECONFIG=${KUBECFG}
76 KUBEGRP=$(id -g -n)
77 fi
78 sudo snap install juju --classic --channel=$JUJU_VERSION/stable
79 }
80
81 function bootstrap_k8s_lxd(){
82 [ -v CONTROLLER ] && ADD_K8S_OPTS="--controller ${CONTROLLER}" && CONTROLLER_NAME=$CONTROLLER
83 [ ! -v CONTROLLER ] && ADD_K8S_OPTS="--client" && BOOTSTRAP_NEEDED="yes" && CONTROLLER_NAME="osm-vca"
84
85 if [ -v BOOTSTRAP_NEEDED ]; then
86 CONTROLLER_PRESENT=$(juju controllers 2>/dev/null| grep ${CONTROLLER_NAME} | wc -l)
87 if [ $CONTROLLER_PRESENT -ge 1 ]; then
88 cat << EOF
89 Threre is already a VCA present with the installer reserved name of "${CONTROLLER_NAME}".
90 You may either explicitly use this VCA with the "--vca ${CONTROLLER_NAME}" option, or remove it
91 using this command:
92
93 juju destroy-controller --release-storage --destroy-all-models -y ${CONTROLLER_NAME}
94
95 Please retry the installation once this conflict has been resolved.
96 EOF
97 exit 1
98 fi
99 else
100 CONTROLLER_PRESENT=$(juju controllers 2>/dev/null| grep ${CONTROLLER_NAME} | wc -l)
101 if [ $CONTROLLER_PRESENT -le 0 ]; then
102 cat << EOF
103 Threre is no VCA present with the name "${CONTROLLER_NAME}". Please specify a VCA
104 that exists, or remove the --vca ${CONTROLLER_NAME} option.
105
106 Please retry the installation with one of the solutions applied.
107 EOF
108 exit 1
109 fi
110 fi
111
112 if [ -v KUBECFG ]; then
113 cat $KUBECFG | juju add-k8s $K8S_CLOUD_NAME $ADD_K8S_OPTS
114 [ -v BOOTSTRAP_NEEDED ] && juju bootstrap $K8S_CLOUD_NAME $CONTROLLER_NAME \
115 --config controller-service-type=loadbalancer \
116 --agent-version=$JUJU_AGENT_VERSION
117 else
118 sg ${KUBEGRP} -c "echo ${DEFAULT_IP}-${DEFAULT_IP} | microk8s.enable metallb"
119 sg ${KUBEGRP} -c "microk8s.enable ingress"
120 sg ${KUBEGRP} -c "microk8s.enable storage dns"
121 TIME_TO_WAIT=30
122 start_time="$(date -u +%s)"
123 while true
124 do
125 now="$(date -u +%s)"
126 if [[ $(( now - start_time )) -gt $TIME_TO_WAIT ]];then
127 echo "Microk8s storage failed to enable"
128 sg ${KUBEGRP} -c "microk8s.status"
129 exit 1
130 fi
131 storage_status=`sg ${KUBEGRP} -c "microk8s.status -a storage"`
132 if [[ $storage_status == "enabled" ]]; then
133 break
134 fi
135 sleep 1
136 done
137
138 [ ! -v BOOTSTRAP_NEEDED ] && sg ${KUBEGRP} -c "microk8s.config" | juju add-k8s $K8S_CLOUD_NAME $ADD_K8S_OPTS
139 [ -v BOOTSTRAP_NEEDED ] && sg ${KUBEGRP} -c \
140 "juju bootstrap microk8s $CONTROLLER_NAME --config controller-service-type=loadbalancer --agent-version=$JUJU_AGENT_VERSION" \
141 && K8S_CLOUD_NAME=microk8s
142 fi
143
144 if [ -v LXD_CLOUD ]; then
145 if [ ! -v LXD_CREDENTIALS ]; then
146 echo "The installer needs the LXD server certificate if the LXD is external"
147 exit 1
148 fi
149 else
150 LXDENDPOINT=$DEFAULT_IP
151 LXD_CLOUD=~/.osm/lxd-cloud.yaml
152 LXD_CREDENTIALS=~/.osm/lxd-credentials.yaml
153 # Apply sysctl production values for optimal performance
154 sudo cp /usr/share/osm-devops/installers/60-lxd-production.conf /etc/sysctl.d/60-lxd-production.conf
155 sudo sysctl --system
156 # Install LXD snap
157 sudo apt-get remove --purge -y liblxc1 lxc-common lxcfs lxd lxd-client
158 sudo snap install lxd --channel $LXD_VERSION/stable
159 # Configure LXD
160 sudo usermod -a -G lxd `whoami`
161 cat /usr/share/osm-devops/installers/lxd-preseed.conf | sed 's/^config: {}/config:\n core.https_address: '$LXDENDPOINT':8443/' | sg lxd -c "lxd init --preseed"
162 sg lxd -c "lxd waitready"
163 DEFAULT_MTU=$(ip addr show $DEFAULT_IF | perl -ne 'if (/mtu\s(\d+)/) {print $1;}')
164 sg lxd -c "lxc profile device set default eth0 mtu $DEFAULT_MTU"
165 sg lxd -c "lxc network set lxdbr0 bridge.mtu $DEFAULT_MTU"
166
167 cat << EOF > $LXD_CLOUD
168 clouds:
169 lxd-cloud:
170 type: lxd
171 auth-types: [certificate]
172 endpoint: "https://$LXDENDPOINT:8443"
173 config:
174 ssl-hostname-verification: false
175 EOF
176 openssl req -nodes -new -x509 -keyout ~/.osm/client.key -out ~/.osm/client.crt -days 365 -subj "/C=FR/ST=Nice/L=Nice/O=ETSI/OU=OSM/CN=osm.etsi.org"
177 local server_cert=`cat /var/snap/lxd/common/lxd/server.crt | sed 's/^/ /'`
178 local client_cert=`cat ~/.osm/client.crt | sed 's/^/ /'`
179 local client_key=`cat ~/.osm/client.key | sed 's/^/ /'`
180
181 cat << EOF > $LXD_CREDENTIALS
182 credentials:
183 lxd-cloud:
184 lxd-cloud:
185 auth-type: certificate
186 server-cert: |
187 $server_cert
188 client-cert: |
189 $client_cert
190 client-key: |
191 $client_key
192 EOF
193 lxc config trust add local: ~/.osm/client.crt
194 fi
195
196 juju add-cloud -c $CONTROLLER_NAME lxd-cloud $LXD_CLOUD --force
197 juju add-credential -c $CONTROLLER_NAME lxd-cloud -f $LXD_CREDENTIALS
198 sg lxd -c "lxd waitready"
199 juju controller-config features=[k8s-operators]
200 }
201
202 function wait_for_port(){
203 SERVICE=$1
204 INDEX=$2
205 TIME_TO_WAIT=30
206 start_time="$(date -u +%s)"
207 while true
208 do
209 now="$(date -u +%s)"
210 if [[ $(( now - start_time )) -gt $TIME_TO_WAIT ]];then
211 echo "Failed to expose external ${SERVICE} interface port"
212 exit 1
213 fi
214
215 if [ $(sg ${KUBEGRP} -c "${KUBECTL} get ingresses.networking -n osm -o json | jq -r '.items[$INDEX].metadata.name'") == ${SERVICE} ] ; then
216 break
217 fi
218 sleep 1
219 done
220 }
221
222 function deploy_charmed_osm(){
223 if [ -v REGISTRY_INFO ] ; then
224 registry_parts=(${REGISTRY_INFO//@/ })
225 if [ ${#registry_parts[@]} -eq 1 ] ; then
226 # No credentials supplied
227 REGISTRY_USERNAME=""
228 REGISTRY_PASSWORD=""
229 REGISTRY_URL=${registry_parts[0]}
230 else
231 credentials=${registry_parts[0]}
232 credential_parts=(${credentials//:/ })
233 REGISTRY_USERNAME=${credential_parts[0]}
234 REGISTRY_PASSWORD=${credential_parts[1]}
235 REGISTRY_URL=${registry_parts[1]}
236 fi
237 # Ensure the URL ends with a /
238 case $REGISTRY_URL in
239 */) ;;
240 *) REGISTRY_URL=${REGISTRY_URL}/
241 esac
242 fi
243
244 echo "Creating OSM model"
245 if [ -v KUBECFG ]; then
246 juju add-model $MODEL_NAME $K8S_CLOUD_NAME
247 else
248 sg ${KUBEGRP} -c "juju add-model $MODEL_NAME $K8S_CLOUD_NAME"
249 fi
250 echo "Deploying OSM with charms"
251 images_overlay=""
252 if [ -v REGISTRY_URL ]; then
253 [ ! -v TAG ] && TAG='latest'
254 fi
255 [ -v TAG ] && generate_images_overlay && images_overlay="--overlay $IMAGES_OVERLAY_FILE"
256
257 if [ -v OVERLAY ]; then
258 extra_overlay="--overlay $OVERLAY"
259 fi
260 echo "Creating Password Overlay"
261
262 generate_password_overlay && secret_overlay="--overlay $PASSWORD_OVERLAY_FILE"
263
264 if [ -v BUNDLE ]; then
265 juju deploy --trust --channel $CHARMHUB_CHANNEL -m $MODEL_NAME $BUNDLE --overlay ~/.osm/vca-overlay.yaml $images_overlay $extra_overlay $secret_overlay
266 else
267 juju deploy --trust --channel $CHARMHUB_CHANNEL -m $MODEL_NAME $OSM_BUNDLE --overlay ~/.osm/vca-overlay.yaml $images_overlay $extra_overlay $secret_overlay
268 fi
269
270 if [ ! -v KUBECFG ]; then
271 API_SERVER=${DEFAULT_IP}
272 else
273 API_SERVER=$(kubectl config view --minify | grep server | cut -f 2- -d ":" | tr -d " ")
274 proto="$(echo $API_SERVER | grep :// | sed -e's,^\(.*://\).*,\1,g')"
275 url="$(echo ${API_SERVER/$proto/})"
276 user="$(echo $url | grep @ | cut -d@ -f1)"
277 hostport="$(echo ${url/$user@/} | cut -d/ -f1)"
278 API_SERVER="$(echo $hostport | sed -e 's,:.*,,g')"
279 fi
280 # Expose OSM services
281 juju config -m $MODEL_NAME nbi site_url=https://nbi.${API_SERVER}.nip.io
282 juju config -m $MODEL_NAME ng-ui site_url=https://ui.${API_SERVER}.nip.io
283 juju config -m $MODEL_NAME grafana site_url=https://grafana.${API_SERVER}.nip.io
284 juju config -m $MODEL_NAME prometheus site_url=https://prometheus.${API_SERVER}.nip.io
285
286 echo "Waiting for deployment to finish..."
287 check_osm_deployed
288 grafana_leader=`juju status -m $MODEL_NAME grafana | grep "*" | cut -d "*" -f 1`
289 grafana_admin_password=`juju run -m $MODEL_NAME --unit $grafana_leader "echo \\$GF_SECURITY_ADMIN_PASSWORD"`
290 juju config -m $MODEL_NAME mon grafana_password=$grafana_admin_password
291 check_osm_deployed
292 echo "OSM with charms deployed"
293 }
294
295 function check_osm_deployed() {
296 TIME_TO_WAIT=600
297 start_time="$(date -u +%s)"
298 total_service_count=14
299 previous_count=0
300 while true
301 do
302 service_count=$(juju status --format json -m $MODEL_NAME | jq '.applications[]."application-status".current' | grep active | wc -l)
303 echo "$service_count / $total_service_count services active"
304 if [ $service_count -eq $total_service_count ]; then
305 break
306 fi
307 if [ $service_count -ne $previous_count ]; then
308 previous_count=$service_count
309 start_time="$(date -u +%s)"
310 fi
311 now="$(date -u +%s)"
312 if [[ $(( now - start_time )) -gt $TIME_TO_WAIT ]];then
313 echo "Timed out waiting for OSM services to become ready"
314 exit 1
315 fi
316 sleep 10
317 done
318 }
319
320 function generate_password_overlay() {
321 # prometheus
322 web_config_password=`openssl rand -base64 16`
323 # keystone
324 keystone_db_password=`openssl rand -base64 16`
325 keystone_admin_password=`openssl rand -base64 16`
326 keystone_service_password=`openssl rand -base64 16`
327 # mariadb
328 mariadb_password=`openssl rand -hex 16`
329 mariadb_root_password=`openssl rand -hex 16`
330 cat << EOF > /tmp/password-overlay.yaml
331 applications:
332 prometheus:
333 options:
334 web_config_password: $web_config_password
335 keystone:
336 options:
337 keystone-db-password: $keystone_db_password
338 admin-password: $keystone_admin_password
339 service-password: $keystone_service_password
340 mariadb:
341 options:
342 password: $mariadb_password
343 root_password: $mariadb_root_password
344 EOF
345 mv /tmp/password-overlay.yaml $PASSWORD_OVERLAY_FILE
346 }
347
348 function create_overlay() {
349 sudo snap install jq
350 sudo snap install yq
351 local HOME=/home/$USER
352 local vca_user=$(cat $HOME/.local/share/juju/accounts.yaml | yq e .controllers.$CONTROLLER_NAME.user - )
353 local vca_secret=$(cat $HOME/.local/share/juju/accounts.yaml | yq e .controllers.$CONTROLLER_NAME.password - )
354 local vca_host=$(cat $HOME/.local/share/juju/controllers.yaml | yq e .controllers.$CONTROLLER_NAME.api-endpoints[0] - | cut -d ":" -f 1)
355 local vca_port=$(cat $HOME/.local/share/juju/controllers.yaml | yq e .controllers.$CONTROLLER_NAME.api-endpoints[0] - | cut -d ":" -f 2)
356 local vca_pubkey=\"$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)\"
357 local vca_cloud="lxd-cloud"
358 # Get the VCA Certificate
359 local vca_cacert=$(cat $HOME/.local/share/juju/controllers.yaml | yq e .controllers.$CONTROLLER_NAME.ca-cert - | base64 | tr -d \\n)
360
361 # Calculate the default route of this machine
362 local DEFAULT_IF=`ip route list match 0.0.0.0 | awk '{print $5}'`
363
364 # Generate a new overlay.yaml, overriding any existing one
365 cat << EOF > /tmp/vca-overlay.yaml
366 applications:
367 lcm:
368 options:
369 vca_user: $vca_user
370 vca_secret: $vca_secret
371 vca_host: $vca_host
372 vca_port: $vca_port
373 vca_pubkey: $vca_pubkey
374 vca_cacert: $vca_cacert
375 vca_cloud: $vca_cloud
376 vca_k8s_cloud: $K8S_CLOUD_NAME
377 mon:
378 options:
379 vca_user: $vca_user
380 vca_secret: $vca_secret
381 vca_host: $vca_host
382 vca_cacert: $vca_cacert
383 EOF
384 mv /tmp/vca-overlay.yaml ~/.osm/
385 OSM_VCA_HOST=$vca_host
386 }
387
388 function generate_images_overlay(){
389 echo "applications:" > /tmp/images-overlay.yaml
390
391 charms_with_resources="nbi lcm mon pol ng-ui ro pla"
392 for charm in $charms_with_resources; do
393 cat << EOF > /tmp/${charm}_registry.yaml
394 registrypath: ${REGISTRY_URL}opensourcemano/${charm}:$TAG
395 EOF
396 if [ ! -z "$REGISTRY_USERNAME" ] ; then
397 echo username: $REGISTRY_USERNAME >> /tmp/${charm}_registry.yaml
398 echo password: $REGISTRY_PASSWORD >> /tmp/${charm}_registry.yaml
399 fi
400
401 cat << EOF >> /tmp/images-overlay.yaml
402 ${charm}:
403 resources:
404 image: /tmp/${charm}_registry.yaml
405
406 EOF
407 done
408 ch_charms_with_resources="keystone"
409 for charm in $ch_charms_with_resources; do
410 cat << EOF > /tmp/${charm}_registry.yaml
411 registrypath: ${REGISTRY_URL}opensourcemano/${charm}:$TAG
412 EOF
413 if [ ! -z "$REGISTRY_USERNAME" ] ; then
414 echo username: $REGISTRY_USERNAME >> /tmp/${charm}_registry.yaml
415 echo password: $REGISTRY_PASSWORD >> /tmp/${charm}_registry.yaml
416 fi
417
418 cat << EOF >> /tmp/images-overlay.yaml
419 ${charm}:
420 resources:
421 ${charm}-image: /tmp/${charm}_registry.yaml
422
423 EOF
424 done
425
426 mv /tmp/images-overlay.yaml $IMAGES_OVERLAY_FILE
427 }
428
429 function refresh_osmclient_snap() {
430 osmclient_snap_install_refresh refresh
431 }
432
433 function install_osm_client_snap() {
434 osmclient_snap_install_refresh install
435 }
436
437 function osmclient_snap_install_refresh() {
438 channel_preference="stable candidate beta edge"
439 for channel in $channel_preference; do
440 echo "Trying to install osmclient from channel $OSMCLIENT_VERSION/$channel"
441 sudo snap $1 osmclient --channel $OSMCLIENT_VERSION/$channel 2> /dev/null && echo osmclient snap installed && break
442 done
443 }
444 function install_osmclient() {
445 snap info osmclient | grep -E ^installed: && refresh_osmclient_snap || install_osm_client_snap
446 }
447
448 function add_local_k8scluster() {
449 osm --all-projects vim-create \
450 --name _system-osm-vim \
451 --account_type dummy \
452 --auth_url http://dummy \
453 --user osm --password osm --tenant osm \
454 --description "dummy" \
455 --config '{management_network_name: mgmt}'
456 tmpfile=$(mktemp --tmpdir=${HOME})
457 cp ${KUBECONFIG} ${tmpfile}
458 osm --all-projects k8scluster-add \
459 --creds ${tmpfile} \
460 --vim _system-osm-vim \
461 --k8s-nets '{"net1": null}' \
462 --version '1.19' \
463 --description "OSM Internal Cluster" \
464 _system-osm-k8s
465 rm -f ${tmpfile}
466 }
467
468 function install_microstack() {
469
470 sudo snap install microstack --beta --devmode
471
472 CHECK=$(microstack.openstack server list)
473 if [ $? -ne 0 ] ; then
474 if [[ $CHECK == *"not initialized"* ]]; then
475 echo "Setting MicroStack dashboard to listen to port 8080"
476 sudo snap set microstack config.network.ports.dashboard=8080
477 echo "Initializing MicroStack. This can take several minutes"
478 sudo microstack.init --auto --control
479 fi
480 fi
481
482 sudo snap alias microstack.openstack openstack
483
484 echo "Updating default security group in MicroStack to allow all access"
485
486 for i in $(microstack.openstack security group list | awk '/default/{ print $2 }'); do
487 for PROTO in icmp tcp udp ; do
488 echo " $PROTO ingress"
489 CHECK=$(microstack.openstack security group rule create $i --protocol $PROTO --remote-ip 0.0.0.0/0 2>&1)
490 if [ $? -ne 0 ] ; then
491 if [[ $CHECK != *"409"* ]]; then
492 echo "Error creating ingress rule for $PROTO"
493 echo $CHECK
494 fi
495 fi
496 done
497 done
498
499 microstack.openstack network show osm-ext &>/dev/null
500 if [ $? -ne 0 ]; then
501 echo "Creating osm-ext network with router to bridge to MicroStack external network"
502 microstack.openstack network create --enable --no-share osm-ext
503 microstack.openstack subnet create osm-ext-subnet --network osm-ext --dns-nameserver 8.8.8.8 \
504 --subnet-range 172.30.0.0/24
505 microstack.openstack router create external-router
506 microstack.openstack router add subnet external-router osm-ext-subnet
507 microstack.openstack router set --external-gateway external external-router
508 fi
509
510 microstack.openstack image list | grep ubuntu20.04 &> /dev/null
511 if [ $? -ne 0 ] ; then
512 echo "Fetching Ubuntu 20.04 image and upLoading to MicroStack"
513 wget -q -O- https://cloud-images.ubuntu.com/focal/current/focal-server-cloudimg-amd64.img \
514 | microstack.openstack image create --public --container-format=bare \
515 --disk-format=qcow2 ubuntu20.04 | grep status
516 fi
517
518 if [ ! -f ~/.ssh/microstack ]; then
519 ssh-keygen -t rsa -N "" -f ~/.ssh/microstack
520 microstack.openstack keypair create --public-key ~/.ssh/microstack.pub microstack
521 fi
522
523 echo "Creating VIM microstack-site in OSM"
524 . /var/snap/microstack/common/etc/microstack.rc
525
526 osm vim-create \
527 --name microstack-site \
528 --user "$OS_USERNAME" \
529 --password "$OS_PASSWORD" \
530 --auth_url "$OS_AUTH_URL" \
531 --tenant "$OS_USERNAME" \
532 --account_type openstack \
533 --config='{use_floating_ip: True,
534 insecure: True,
535 keypair: microstack,
536 management_network_name: osm-ext}'
537 }
538
539 DEFAULT_IF=`ip route list match 0.0.0.0 | awk '{print $5; exit}'`
540 DEFAULT_IP=`ip -o -4 a |grep ${DEFAULT_IF}|awk '{split($4,a,"/"); print a[1]; exit}'`
541
542 check_arguments $@
543 mkdir -p ~/.osm
544 install_snaps
545 bootstrap_k8s_lxd
546 create_overlay
547 if [ -v ONLY_VCA ]; then
548 HOME=/home/$USER
549 vca_user=$(cat $HOME/.local/share/juju/accounts.yaml | yq e .controllers.$CONTROLLER_NAME.user - )
550 vca_secret=$(cat $HOME/.local/share/juju/accounts.yaml | yq e .controllers.$CONTROLLER_NAME.password - )
551 vca_host=$(cat $HOME/.local/share/juju/controllers.yaml | yq e .controllers.$CONTROLLER_NAME.api-endpoints[0] - | cut -d ":" -f 1)
552 vca_port=$(cat $HOME/.local/share/juju/controllers.yaml | yq e .controllers.$CONTROLLER_NAME.api-endpoints[0] - | cut -d ":" -f 2)
553 vca_pubkey=\"$(cat $HOME/.local/share/juju/ssh/juju_id_rsa.pub)\"
554 vca_cloud="lxd-cloud"
555 vca_cacert=$(cat $HOME/.local/share/juju/controllers.yaml | yq e .controllers.$CONTROLLER_NAME.ca-cert - | base64 | tr -d \\n)
556 hostname=`cat /etc/hostname`
557
558 echo "Use the following command to register the installed VCA to your OSM:"
559 echo -e " osm vca-add --endpoints $vca_host:$vca_port \\\n --user $vca_user \\\n --secret $vca_secret \\\n --cacert $vca_cacert \\\n --lxd-cloud lxd-cloud \\\n --lxd-credentials lxd-cloud \\\n --k8s-cloud microk8s \\\n --k8s-credentials microk8s\\\n $hostname-vca"
560 else
561 deploy_charmed_osm
562 install_osmclient
563 export OSM_HOSTNAME=$(juju config -m $MODEL_NAME nbi site_url | sed "s/http.*\?:\/\///"):443
564 export OSM_PASSWORD=$keystone_admin_password
565 sleep 10
566 add_local_k8scluster
567 if [ -v MICROSTACK ]; then
568 install_microstack
569 fi
570
571 echo "Your installation is now complete, follow these steps for configuring the osmclient:"
572 echo
573 echo "1. Create the OSM_HOSTNAME environment variable with the NBI IP"
574 echo
575 echo "export OSM_HOSTNAME=$OSM_HOSTNAME"
576 echo "export OSM_PASSWORD=$OSM_PASSWORD"
577 echo
578 echo "2. Add the previous commands to your .bashrc for other Shell sessions"
579 echo
580 echo "echo \"export OSM_HOSTNAME=$OSM_HOSTNAME\" >> ~/.bashrc"
581 echo "echo \"export OSM_PASSWORD=$OSM_PASSWORD\" >> ~/.bashrc"
582 echo
583 echo "3. Login OSM GUI by using admin password: $OSM_PASSWORD"
584 echo
585 echo "DONE"
586 fi
587